#include "app_config.h"

#include <cpu_timer.h>
#include <ami_stream.h>
#include <union_find.h>

#include <streamio.h>

int main(int argc, char **argv) {
	if (argc < 2) {
		cout << argv[0] << " streamfilename\n";
		return 1;
	}

	MM_manager.set_memory_limit(800*1024*1024);
	MM_manager.ignore_memory_limit();

	AMI_STREAM<uf_t<int, int> > *s = new AMI_STREAM<uf_t<int, int> >(argv[1]);
	s->persist(PERSIST_DELETE);

	AMI_STREAM<int> *s1 = new AMI_STREAM<int>("em.out");
	s1->persist(PERSIST_PERSISTENT);
	s1->truncate(0);
	
	cpu_timer total_time;
	total_time.reset();
	total_time.start();

	union_find(s, s1);
	
	total_time.stop();
	cout << "Total time: " << total_time << endl;

	delete s1;
	return 0;
}
